#include <cmath>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

struct point {
    double x , y;
    
    point() {}
    point ( double _x , double _y ) {
        x = _x; y = _y;
    }
};

struct el {
    int sq;
    point a[4];
};

int m , n , a , k;
vector < el > f;
double s;

void read() {
    int i;
    int type;
    int x , y;
    el t;
    
    f.clear();
    
    scanf ( "%d%d%d%d" , &m , &n , &a , &k );
    f.reserve ( k );
    
    for (i = 1; i <= k; i++) {
        scanf ( "%d%d%d" , &type , &x , &y );
        
        if ( type == 0 ) {
            t.sq = 1;
            t.a[0] = point ( x , y );
            t.a[1] = point ( x + a , y );
            t.a[2] = point ( x + a , y + a );
            t.a[3] = point ( x , y + a );
        } else {
            t.sq = 0;
            t.a[0] = point ( x , y );
            
            if ( type == 1 || type == 3 ) t.a[1] = point ( x , y + a );
            else t.a[1] = point ( x , y - a );
            
            if ( type == 1 || type == 2 ) t.a[2] = point ( x + a , y );
            else t.a[2] = point ( x - a , y );
        }
        
        f.push_back ( t );
    }
}

double cross ( point a , point b , point c ) {
    return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

double area ( el &f ) {
    if ( f.sq ) 
        return (f.a[1].x - f.a[0].x) * (f.a[2].y - f.a[0].y);
    else
        return fabs ( cross ( f.a[0] , f.a[1] , f.a[2] ) ) / 2.;
}

double intersect ( point l1 , point r1 , point l2 , point r2 ) {
    return l1.x + (r1.x - l1.x) * cross ( l1 , l2 , r2 ) / ( cross ( l1 , l2 , r1 ) + cross ( l1 , r1 , r2 ) );
}

double median ( el &f ) {
    if ( f.sq ) return f.a[0].x + (f.a[1].x - f.a[0].x) / 2.;
    else {
        point m1 , m2;
        
        m1 = point ( f.a[1].x + (f.a[1].x - f.a[2].x) / 2. , f.a[1].y + (f.a[1].y - f.a[2].y) / 2. );
        m2 = point ( f.a[0].x + (f.a[0].x - f.a[1].x) / 2. , f.a[0].y + (f.a[0].y - f.a[1].y) / 2. );
        
        return intersect ( f.a[0] , m1 , f.a[2] , m2 );
    }
}

void solve() {
    int i;
    el t , h;
    double l , r;
    double ans = 0.;
    
    s = (double)n / 2.;
    
    for (i = 0; i < (int)f.size(); i++) {
        t = f[i];
        
        l = min ( t.a[0].x , min ( t.a[1].x , t.a[2].x ) );
        if ( t.sq ) l = min ( l , t.a[3].x );
        
        r = max ( t.a[0].x , max ( t.a[1].x , t.a[2].x ) );
        if ( t.sq ) r = max ( r , t.a[3].x );
        
        if ( s - l > 1e-9 && r - s > 1e-9 ) {
            if ( t.sq ) {
                h.sq = 1;
                h.a[0] = t.a[0];
                h.a[1] = point ( s , t.a[0].y );
                h.a[2] = point ( s , t.a[0].y + a );
                h.a[3] = t.a[3];
                
                f[i] = h;
                
                h.a[0] = point ( s , t.a[0].y );
                h.a[1] = t.a[1];
                h.a[2] = t.a[2];
                h.a[3] = point ( s , t.a[0].y + a );
                
                f.push_back ( h );
            }
        }
    }
    
    for (i = 0; i < (int)f.size(); i++) {
        l = min ( t.a[0].x , min ( t.a[1].x , t.a[2].x ) );
        if ( t.sq ) l = min ( l , t.a[3].x );
            
    //    printf ( "%lf   %lf\n" , median ( f[i] ) , area ( f[i] ) );
        ans += (s - median ( f[i] )) * area ( f[i] );
    }
        
//    printf ( "%lf\n" , ans );
        
    if ( fabs ( ans ) < 1e-9 )
        printf ( "0\n" );
    else
        if ( ans > 1e-9 )
            printf ( "1\n" );
        else
            printf ( "-1\n" );
}

int main() {
    int cases;
    
    scanf ( "%d" , &cases );
    while ( cases -- ) {
        read();
        solve();
    }
    
    return 0;
}
